%=====================================================
% CODE scdl
%
% Code for steady one-dimensional convection-diffusion
% with linear elements (scdl)
%=====================================================

%-----------
% input data
%-----------

L=1.0; k=1.0; q0 = -1.00; ht=1.0; finf=0.0;fL=0.0;
rho=1.0; cp=1.0;
ne=16; ratio=1.0;
U=100.0;

%---------------
% grid generation
%---------------

xe=elm_line1 (0,L,ne,ratio);

%-------------------
% specify the source
%-------------------

for i=1:ne+1
 s(i) = 10.0*exp(-5.0*xe(i)^2/L^2);
end

%-----------------
% element assembly
%-----------------

[at,bt,ct,b] = scdl_sys (ne,xe,q0,ht,finf,fL,k,U,rho,cp,s);

%--------------
% linear solver
%--------------

f = thomas(ne,at,bt,ct,b);

f(ne+1) = fL;

%-----
% plot
%-----

plot(xe, f,'-o');

xlabel('x'); ylabel('f');

%-----
% done
%-----
