%========================================
% Code: discr_s_dr
%
% Driver for discretizing the interval (0, L)
% into "ne" elements,
% and defining the Lobatto element interpolation nodes
%========================================

%-----------
% Input data
%-----------

L=1.0;
ne=2;      % number of elements
ratio=3.0;  % stretch ratio
np(1)=6; np(2) = 4;  % element expansion order

%-----------
% discretize
%-----------

[xe,xen,xg,c,ng] = discr_s(0,L,ne,ratio,np);

%-----
% plot
%-----

yg= zeros(ng,1);
plot(xg,yg,'-d');   % global nodes
hold on;

ye= zeros(ne+1,1);
plot(xe,ye,'o')    % end nodes

axis([ 0 L -0.10*L 0.10*L])
xlabel('x')

%-----
% done
%-----
