%=======
% fekete_nodes
%
% prepare a graph of the element interpolation functions
% for the fekete node distribution
%=======

m=6;

[t, W] = lobatto(m-1);    % W is unused

v(1) = 0.0;
for i=2:m
 v(i) = 0.5*(1.0+t(i-1));
end
v(m+1) = 1.0;

%-------------
% uniform grid
%-------------

%for i=1:m+1
%  v(i) = (i-1.0)/m
%end

%---------------
% lobatto nodes
%---------------

zz = 0.0;

for i=1:m+1
   for j=1:m+2-i
%     xx = v(i);
%     yy = v(j);
       k = m+3-i-j;
       xx = (1.0+2.0*v(i)-v(j)-v(k))/3.0;
       yy = (1.0+2.0*v(j)-v(i)-v(k))/3.0;
     plot3(xx,yy,zz,'o'); hold on;
   end
end

%=====================
% fekete nodes for m=6
%=====================

fx = 1.0/3.0; fy = 1.0/3.0;
plot(fx,fy,'x');
fx = 0.1063354684; fy = 0.1063354684;
plot(fx,fy,'x');
fx = 0.1171809171; fy = 0.3162697959;
plot(fx,fy,'x');
fx = 0.0; fy = 0.5;
plot(fx,fy,'x');
fx = 0.0; fy = 0.0;
plot(fx,fy,'x');
fx = 0.0; fy = 1.0;
plot(fx,fy,'x');
fx = 0.0; fy = 0.2655651402;
plot(fx,fy,'x');
fx = 0.0; fy = 1.0-0.2655651402;
plot(fx,fy,'x');
fx = 0.0; fy = 0.0848854223;
plot(fx,fy,'x');
fx = 0.0; fy = 1.0-0.0848854223;
plot(fx,fy,'x');

%==================
% plot the triangle
%==================

zz(1)=0.0; zz(2)=0.0; zz(3)=0.0; zz(4)=0.0;

xx(1)=v(1);   yy(1)=v(1);
xx(2)=v(m+1); yy(2)=v(1);
xx(3)=v(1);   yy(3)=v(m+1);
xx(4)=v(1);   yy(4)=v(1);

plot3(xx,yy,zz); hold on;
axis([0 1 0 1 0 1]);

%==============================
% map to an equilateral triangle
%==============================

figure; hold on;

for i=1:m+1
   for j=1:m+2-i
%     xx = v(i);
%     yy = v(j);
       k = m+3-i-j;
       xx = (1.0+2.0*v(i)-v(j)-v(k))/3.0;
       yy = (1.0+2.0*v(j)-v(i)-v(k))/3.0;
     xx = xx+0.5*yy;
     yy = sqrt(3)*yy/2.0;
     plot3(xx,yy,zz,'o'); hold on;
   end
end

%%%%%%
% fekete
%%%%%%%

fx = 1.0/3.0; fy = 1.0/3.0;xx = fx+0.5*fy;yy = sqrt(3)*fy/2.0;
plot3(xx,yy,zz,'+');
xc=xx;yc=yy;
     
fx = 0.1063354684; fy = 0.1063354684;
     xx = fx+0.5*fy;yy = sqrt(3)*fy/2.0;
     plot3(xx,yy,zz,'+');
     xx = 1.0-xx;plot3(xx,yy,zz,'+');xx=1.0-xx;
     yy=sqrt(3)/2.0-sqrt(xx^2+yy^2);
     xx = 0.5; 
     plot3(xx,yy,zz,'+');

fx = 0.1171809171; fy = 0.3162697959;
     xx = fx+0.5*fy;
     yy = sqrt(3)*fy/2.0;
     plot3(xx,yy,zz,'+');
     xx = 1.0-xx;plot3(xx,yy,zz,'+');xx=1.0-xx;
fy = 0.1171809171; fx = 0.3162697959;
     xx = fx+0.5*fy;
     yy = sqrt(3)*fy/2.0;
     plot3(xx,yy,zz,'+');
     xx = 1.0-xx;plot3(xx,yy,zz,'+');xx=1.0-xx;
%     xx = 2.0*xc-xx; yy=2.0*yc-yy;
%     plot3(xx,yy,zz,'+');

fx = 0.0; fy = 0.0;xx = fx+0.5*fy;yy = sqrt(3)*fy/2.0;plot3(xx,yy,zz,'+');
     xx = 1.0-xx;plot3(xx,yy,zz,'+');
fx = 0.0; fy = 0.0848854223;xx = fx+0.5*fy;yy = sqrt(3)*fy/2.0;
     plot3(xx,yy,zz,'+');
     xx = 1.0-xx;plot3(xx,yy,zz,'+');
fy = 0.0; fx = 0.0848854223;xx = fx+0.5*fy;yy = sqrt(3)*fy/2.0;
     plot3(xx,yy,zz,'+');
fx = 0.0; fy = 0.2655651402;xx = fx+0.5*fy;yy = sqrt(3)*fy/2.0;plot3(xx,yy,zz,'+');
     xx = 1.0-xx;plot3(xx,yy,zz,'+');
fy = 0.0; fx = 0.2655651402;xx = fx+0.5*fy;yy = sqrt(3)*fy/2.0;plot3(xx,yy,zz,'+');
     xx = 1.0-xx;plot3(xx,yy,zz,'+');
fx = 0.0; fy = 0.5;xx = fx+0.5*fy;yy = sqrt(3)*fy/2.0;plot3(xx,yy,zz,'+');
     xx = 1.0-xx;plot3(xx,yy,zz,'+');
fy = 0.0; fx = 0.5;xx = fx+0.5*fy;yy = sqrt(3)*fy/2.0;plot3(xx,yy,zz,'+');
fx = 0.0; fy = 1.0-0.2655651402;xx = fx+0.5*fy;yy = sqrt(3)*fy/2.0;
     plot3(xx,yy,zz,'+');
     xx = 1.0-xx;plot3(xx,yy,zz,'+');
fy = 0.0; fx = 1.0-0.2655651402;xx = fx+0.5*fy;yy = sqrt(3)*fy/2.0;
     plot3(xx,yy,zz,'+');
fx = 0.0; fy = 1.0-0.0848854223;xx = fx+0.5*fy;yy = sqrt(3)*fy/2.0;
     plot3(xx,yy,zz,'+');
     xx = 1.0-xx;plot3(xx,yy,zz,'+');
fy = 0.0; fx = 1.0-0.0848854223;xx = fx+0.5*fy;yy = sqrt(3)*fy/2.0;
     plot3(xx,yy,zz,'+');
fx = 0.0; fy = 1.0;
     xx = fx+0.5*fy;
     yy = sqrt(3)*fy/2.0;
     plot3(xx,yy,zz,'+');

%==============================
% plot the equilateral triangle
%==============================

zzp(1)=0.0;zzp(2)=0.0;zzp(3)=0.0;zzp(4)=0.0;

xxp(1)=0.0;   yyp(1)=0.0;
xxp(2)=1.0;   yyp(2)=0.0;
xxp(3)=0.5;   yyp(3)=sqrt(3)/2.0;
xxp(4)=0.0;   yyp(4)=0.0;

%xxp = xxp - 0.50;yyp = yyp - 1.0/3.0;

plot3(xxp,yyp,zzp); hold on;
axis([0 1 0 1 0 1]);

break;

%-----
% Done
%-----
