%=======
% Legendre triangle nodes
%
% display the
% Legendre nodes on the triangle
%=======

%---------
% legendre
%---------

m=1;
c = -0.57735026918962576450;
v(1) = 0.5*(1.0+c);
c=-c;
v(2) = 0.5*(1.0+c);

m=2;
c = -0.77459666924148337703;
v(1) = 0.5*(1.0+c);
v(2) = 0.5;
c=-c;
v(3) = 0.5*(1.0+c);

%-------------
% uniform grid
%-------------

%for i=1:m+1
%  v(i) = (i-1.0)/m
%end

%---------------
% Legendre nodes
%---------------

zz = 0.0;

for i=1:m+1
   for j=1:m+2-i
       k = m+3-i-j;
%       xx = (1.0+2.0*v(i)-v(j)-v(k))/3.0;   % symmetric
%       yy = (1.0+2.0*v(j)-v(i)-v(k))/3.0;
        xx = v(i);                          % biased
        yy = v(j);
     plot3(xx,yy,zz,'o'); hold on;
   end
end

%==================
% plot the triangle
%==================

zz(1)=0.0; zz(2)=0.0; zz(3)=0.0; zz(4)=0.0;

xx(1)=0; yy(1)=0;
xx(2)=1; yy(2)=0;
xx(3)=0; yy(3)=1;
xx(4)=0; yy(4)=0;

plot3(xx,yy,zz); hold on;
axis([0 1 0 1 0 1]);
xlabel('x');ylabel('y');


%==============================
% map to an equilateral triangle
%==============================

figure; hold on;

for i=1:m+1
   for j=1:m+2-i
       k = m+3-i-j;
       xx = (1.0+2.0*v(i)-v(j)-v(k))/3.0;    % symmetric
       yy = (1.0+2.0*v(j)-v(i)-v(k))/3.0;
%      xx = v(i);      % biased
%      yy = v(j);
      xx = xx+0.5*yy; 
      yy = sqrt(3)*yy/2.0;
     plot3(xx,yy,zz,'o'); hold on;
   end
end

%==============================
% plot the equilateral triangle
%==============================

zzp(1)=0.0; zzp(2)=0.0; zzp(3)=0.0; zzp(4)=0.0;

xxp(1)=0.0;   yyp(1)=0.0;
xxp(2)=1.0;   yyp(2)=0.0;
xxp(3)=0.5;   yyp(3)=sqrt(3)/2.0;
xxp(4)=0.0;   yyp(4)=0.0;

%xxp = xxp - 0.50;yyp = yyp - 1.0/3.0;

plot3(xxp,yyp,zzp); hold on;
axis([0 1 0 1 0 1]);
xlabel('x');ylabel('y');

%-----
% done
%-----
