%===========================================
% proriol_graph
%
% prepare graphs of the Proriol polynomials
%===========================================

ipr = 1;  % Order
jpr = 1;  % Order

%--------------
% plotting grid
%--------------

N=32; M=32;   % plotting grid

Dx=1.0/N; Dy=1.0/M;

for i=1:N+1 
  x(i)=Dx*(i-1.0);
%   fprintf (1,'%6.2f',X(i))
end

for j=1:M+1
  y(j)=Dy*(j-1.0);
% fprintf (1,'%6.2f',Y(j))
end

%---
% vertical lines
%---

for i=1:N
for j=1:M+2-i
 xp(j) = x(i);
 yp(j) = y(j);
 zeta= 1.0-xp(j)-yp(j);

 xii = xp(j); eta=yp(j);
 if(eta>0.999999) eta=0.999999; end
 xip = 2*xii/(1-eta)-1; etap = 2*eta-1;

% zp(j) = xp(j)-zeta;     % P_10
% zp(j) = 3*eta-1;        % P_01
% zp(j) = 6*xii^2 + 6*xii*eta + eta^2 - 6*xii-2*eta + 1; % P_20
% zp(j) = (2*xii+eta-1)*(5*eta-1); % P_11
% zp(j) = 10*eta^2 - 8*eta + 1; % P_02

 zp(j) = jacobi(0,0,ipr,xip) *(1-eta)^ipr * jacobi(2*ipr+1,0,jpr,etap) ;
% zp(j) = zp(j)^2;

end
plot3(xp,yp,zp); hold on;
end

%---
% horizontal lines
%---

for j=1:M
for i=1:N+2-j
 ypp(i) = y(j);
 xpp(i) = x(i);
 zeta= 1.0-xpp(i)-ypp(i);

 xii = xpp(i); eta=ypp(i);
 if(eta>0.999999) eta=0.999999; end
 xip = 2*xii/(1-eta)-1; etap = 2*eta-1;

 % zpp(i) = xii-zeta; % P_10
 % zpp(i) = 3*eta-1;   % P_01
 % zpp(i) = 6*xii^2 + 6*xii*eta + eta^2 - 6*xii-2*eta + 1; % P_20
 % zpp(i) = (2*xii+eta-1)*(5*eta-1);  % P_11
 % zpp(i) = 10*eta^2 - 8*eta + 1; % P_02

 zpp(i) = jacobi(0,0,ipr,xip) *(1-eta)^ipr * jacobi(2*ipr+1,0,jpr,etap) ;

% zpp(i) = zpp(i)^2;

end
plot3 (xpp,ypp,zpp);
end

%------------------
% plot the triangle
%------------------

xx(1)=0.0; yy(1)=0.0; zz(1)=0.0;
xx(2)=1.0; yy(2)=0.0; zz(2)=0.0;
xx(3)=0.0; yy(3)=1.0; zz(3)=0.0;
xx(4)=0.0; yy(4)=0.0; zz(4)=0.0;

plot3(xx,yy,zz);

% xlabel('x'); ylabel('y');

%-----
% done
%-----
