 function [x1,y1,z1, x2,y2,z2, x3,y3,z3, x4,y4,z4 ...
          ,x5,y5,z5, x6,y6,z6, x7,y7,z7, x8,y8,z8 ...
          ,x9,y9,z9, x10,y10,z10, x11,y11,z11, x12,y12,z12] ...
          = tetra4_sub (x,y,z)

%========================
% tetra4_sub
%
% subdivide a tetrahedron
%========================

% mid-edge nodes

x12=0.5*(x(1)+x(2)); y12=0.5*(y(1)+y(2)); z12=0.5*(z(1)+z(2));
x13=0.5*(x(1)+x(3)); y13=0.5*(y(1)+y(3)); z13=0.5*(z(1)+z(3));
x14=0.5*(x(1)+x(4)); y14=0.5*(y(1)+y(4)); z14=0.5*(z(1)+z(4));
x23=0.5*(x(2)+x(3)); y23=0.5*(y(2)+y(3)); z23=0.5*(z(2)+z(3));
x24=0.5*(x(2)+x(4)); y24=0.5*(y(2)+y(4)); z24=0.5*(z(2)+z(4));
x34=0.5*(x(3)+x(4)); y34=0.5*(y(3)+y(4)); z34=0.5*(z(3)+z(4));

% centroid

xc = 0.25*(x(1)+x(2)+x(3)+x(4));
yc = 0.25*(y(1)+y(2)+y(3)+y(4));
zc = 0.25*(z(1)+z(2)+z(3)+z(4));

vlm = 0.0;

%------------------
% first tetrahedron
%------------------

x1(1)=x13;  y1(1)=y13;  z1(1)=z13;
x1(2)=x23;  y1(2)=y23;  z1(2)=z23;
x1(3)=x(3); y1(3)=y(3); z1(3)=z(3);
x1(4)=x34;  y1(4)=y34;  z1(4)=z34;

%------------------
% second tetrahedron
%------------------

x2(1)=x12;  y2(1)=y12;  z2(1)=z12;
x2(2)=x(2); y2(2)=y(2); z2(2)=z(2);
x2(3)=x23;  y2(3)=y23;  z2(3)=z23;
x2(4)=x24;  y2(4)=y24;  z2(4)=z24;

%------------------
% third tetrahedron
%------------------

x3(1)=x14;  y3(1)=y14;  z3(1)=z14;
x3(2)=x24;  y3(2)=y24;  z3(2)=z24;
x3(3)=x34;  y3(3)=y34;  z3(3)=z34;
x3(4)=x(4); y3(4)=y(4); z3(4)=z(4);

%-------------------
% fourth tetrahedron
%-------------------

x4(1)=x(1); y4(1)=y(1); z4(1)=z(1);
x4(2)=x12;  y4(2)=y12;  z4(2)=z12;
x4(3)=x13;  y4(3)=y13;  z4(3)=z13;
x4(4)=x14;  y4(4)=y14;  z4(4)=z14;

%-------------------
% fifth tetrahedron
%-------------------

x5(1)=x13;  y5(1)=y13;  z5(1)=z13;
x5(2)=x23;  y5(2)=y23;  z5(2)=z23;
x5(3)=x34;  y5(3)=y34;  z5(3)=z34;
x5(4)=xc;   y5(4)=yc;   z5(4)=zc;

%------------------
% sixth tetrahedron
%------------------

x6(1)=x12; y6(1)=y12; z6(1)=z12;
x6(2)=x24; y6(2)=y24; z6(2)=z24;
x6(3)=x23; y6(3)=y23; z6(3)=z23;
x6(4)=xc;  y6(4)=yc;  z6(4)=zc;

%--------------------
% seventh tetrahedron
%--------------------

x7(1)=x14; y7(1)=y14; z7(1)=z14;
x7(2)=x34; y7(2)=y34; z7(2)=z34;
x7(3)=x24; y7(3)=y24; z7(3)=z24;
x7(4)=xc;  y7(4)=yc;  z7(4)=zc;

%-------------------
% eighth tetrahedron
%-------------------

x8(1)=x14; y8(1)=y14; z8(1)=z14;
x8(2)=x12; y8(2)=y12; z8(2)=z12;
x8(3)=x13; y8(3)=y13; z8(3)=z13;
x8(4)=xc;  y8(4)=yc;  z8(4)=zc;

%-------------------
% ninth tetrahedron
%-------------------

x9(1)=x24; y9(1)=y24; z9(1)=z24;
x9(2)=x34; y9(2)=y34; z9(2)=z34;
x9(3)=x23; y9(3)=y23; z9(3)=z23;
x9(4)=xc;  y9(4)=yc;  z9(4)=zc;

%-------------------
% tenth tetrahedron
%-------------------

x10(1)=x14; y10(1)=y14; z10(1)=z14;
x10(2)=x13; y10(2)=y13; z10(2)=z13;
x10(3)=x34; y10(3)=y34; z10(3)=z34;
x10(4)=xc;  y10(4)=yc;  z10(4)=zc;

%-------------------
% eleventh tetrahedron
%-------------------

x11(1)=x14; y11(1)=y14; z11(1)=z14;
x11(2)=x24; y11(2)=y24; z11(2)=z24;
x11(3)=x12; y11(3)=y12; z11(3)=z12;
x11(4)=xc;  y11(4)=yc;  z11(4)=zc;

%-------------------
% twelfth tetrahedron
%-------------------

x12(1)=x12; y12(1)=y12; z12(1)=z12;
x12(2)=x23; y12(2)=y23; z12(2)=z23;
x12(3)=x13; y12(3)=y13; z12(3)=z13;
x12(4)=xc;  y12(4)=yc;  z12(4)=zc;

%-----
% done
%-----

return
