%========================
% tetra4_sub_dr
%
% driver for subdividing
% a tetrahedron
%========================
                                                                                
% constants
                                                                                
  wait=0.5;
                                                                                
% arbitrary vertex coordinates:
                                                                                
 x(1) = 0.0; y(1)= 0.0; z(1)= 0.0;
 x(2) = 0.9; y(2)= 0.2; z(2)= 0.5;
 x(3) = 0.1; y(3)= 1.1; z(3)=-0.05;
 x(4) =-0.1; y(4)=-0.1; z(4)= 1.2;

% canonical vertex coordinates:
                                                                                
 x(1) = 0.0; y(1) = 0.0; z(1)= 0.0;
 x(2) = 1.0; y(2) = 0.0; z(2)= 0.0;
 x(3) = 0.0; y(3) = 1.0; z(3)= 0.0;
 x(4) = 0.0; y(4) = 0.0; z(4)= 1.0;
                                                                                
%  canonical regular tetrahedron:
                                                                                
    for j=1:4
     x(j) = x(j)+0.5*(y(j)+z(j));
     y(j) = 0.5*sqrt(3)*(y(j)+z(j)/3.0);
     z(j) = sqrt(2/3)*z(j);
    end

%---
% subdivide
%---

 [x1,y1,z1, x2,y2,z2, x3,y3,z3, x4,y4,z4 ...
 ,x5,y5,z5, x6,y6,z6, x7,y7,z7, x8,y8,z8 ...
 ,x9,y9,z9, x10,y10,z10, x11,y11,z11, x12,y12,z12] ...
 ...
 = tetra4_sub(x,y,z);

%----------
% visualize
%----------

 option = 2; % wireframe

 volume = tetra4_vis (x,y,z,option);

 option = 1; % in color

 for i=1:10 vol(i)=0; end

% vol(1) =tetra4_vis (x1, y1, z1, option);pause(wait);
% vol(2) =tetra4_vis (x2, y2, z2, option);pause(wait);
% vol(3) =tetra4_vis (x3, y3, z3, option);pause(wait);
% vol(4) =tetra4_vis (x4, y4, z4, option);pause(wait);
% vol(5) =tetra4_vis (x5, y5, z5, option);pause(wait);
 vol(6) =tetra4_vis (x6, y6, z6, option);pause(wait);
 vol(7) =tetra4_vis (x7, y7, z7, option);pause(wait);
 vol(8) =tetra4_vis (x8, y8, z8, option);pause(wait);
 vol(9) =tetra4_vis (x9, y9, z9, option);pause(wait);
 vol(10)=tetra4_vis (x10,y10,z10,option);pause(wait);
 vol(11)=tetra4_vis (x11,y11,z11,option);pause(wait);
 vol(12)=tetra4_vis (x12,y12,z12,option);

%--------
% volumes
%--------

 vlm= 0.0;
 for i=1:12
%   vol(i)
  vlm = vlm+vol(i);
 end

 vlm
 volume

%-----
% done
%-----

