 function volume = tetra4_vis (x,y,z,option)

%========================
% tetra4_vis
%
% visualize a tetrahedron
% defined by the three
% vertices: x, y, z
%========================

% face node labels:

s(1,1)=2; s(1,2)=3; s(1,3)=4;    % face 1
s(2,1)=3; s(2,2)=1; s(2,3)=4;    % face 2
s(3,1)=1; s(3,2)=2; s(3,3)=4;    % face 3
s(4,1)=1; s(4,2)=2; s(4,3)=3;    % face 4

% paint the faces:

for i=1:4

 for j=1:3

  xv = x(s(i,j));
  yv = y(s(i,j));
  zv = z(s(i,j));

  xp(j)=xv; yp(j)=yv; zp(j)=zv;


 end

  if(option==1)
       if(i==1) patch(xp,yp,zp,'r'); end
       if(i==2) patch(xp,yp,zp,'b'); end
       if(i==3) patch(xp,yp,zp,'y'); end
       if(i==4) patch(xp,yp,zp,'g'); end
   else
       plot3 (xp,yp,zp); hold on;    % wireframe
   end
end

xlabel('x'); ylabel('y'); zlabel('z');
axis([-0.3 1.3 -0.3 1.3 -0.3 1.3]);

%-------------------
% compute the volume
%-------------------

matrix=[1 1 1 1; x(1) x(2) x(3) x(4); y(1) y(2) y(3) y(4);
                 z(1) z(2) z(3) z(4)];
volume = det(matrix);

%-----
% done
%-----

return
